<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>net.cubekrowd</groupId>
    <artifactId>globalvanish</artifactId>
    <version>2.0.1-SNAPSHOT</version>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    </properties>

    <distributionManagement>
        <repository>
            <id>cubekrowd-public-releases</id>
            <url>https://mavenrepo.cubekrowd.net/artifactory/public-release-local/</url>
        </repository>
        <snapshotRepository>
            <id>cubekrowd-public-snapshots</id>
            <url>https://mavenrepo.cubekrowd.net/artifactory/public-snapshot-local/</url>
        </snapshotRepository>
    </distributionManagement>

    <repositories>
        <repository>
            <id>cubekrowd-repo</id>
            <url>https://mavenrepo.cubekrowd.net/artifactory/repo/</url>
        </repository>
    </repositories>

    <pluginRepositories>
        <pluginRepository>
            <id>apache.snapshots</id>
            <url>https://repository.apache.org/snapshots/</url>
        </pluginRepository>
    </pluginRepositories>

    <dependencies>
        <dependency>
            <groupId>org.spigotmc</groupId>
            <artifactId>spigot-api</artifactId>
            <version>1.17-R0.1-SNAPSHOT</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>de.myzelyam</groupId>
            <artifactId>SuperVanish</artifactId>
            <version>6.1.3</version>
            <scope>provided</scope>
        </dependency>
        <dependency>
            <groupId>io.lettuce</groupId>
            <artifactId>lettuce-core</artifactId>
            <version>5.3.1.RELEASE</version>
        </dependency>
    </dependencies>

    <build>
        <resources>
            <resource>
                <directory>src/main/resources</directory>
                <filtering>true</filtering>
            </resource>
        </resources>

        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.0</version>
                <configuration>
                    <source>16</source>
                    <target>16</target>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-shade-plugin</artifactId>
                <version>3.3.0-SNAPSHOT</version>

                <configuration>
                    <relocations>
                        <relocation>
                            <pattern>io.lettuce</pattern>
                            <shadedPattern>net.cubekrowd.globalvanish.lib.lettuce</shadedPattern>
                        </relocation>
                        <relocation>
                            <pattern>io.netty</pattern>
                            <shadedPattern>net.cubekrowd.globalvanish.lib.netty</shadedPattern>
                        </relocation>
                        <relocation>
                            <pattern>reactor</pattern>
                            <shadedPattern>net.cubekrowd.globalvanish.lib.reactor</shadedPattern>
                        </relocation>
                        <relocation>
                            <pattern>org.reactivestreams</pattern>
                            <shadedPattern>net.cubekrowd.globalvanish.lib.reactivestreams</shadedPattern>
                        </relocation>
                    </relocations>
                    <minimizeJar>true</minimizeJar>
                </configuration>

                <executions>
                    <execution>
                        <id>shade</id>
                        <phase>package</phase>
                        <goals>
                            <goal>shade</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-deploy-plugin</artifactId>
                <version>3.0.0-M1</version>
            </plugin>
        </plugins>
    </build>
</project>
